//Copyright 2014,2015 MCbx, All rights reserved.
//http://mcbx.netne.net/ictester
//This file is part of ICTester.
//ICTester is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//ICTester is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//You should have received a copy of the GNU General Public License
//along with ICTester; if not, write to the Free Software Foundation,
//Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef TESTLOG_H
#define TESTLOG_H

#include <QWidget>
#include <QTreeWidget>

class TestLog : public QWidget
{
    Q_OBJECT
public:
    explicit TestLog(QTreeWidget * component, QWidget *parent = 0);

    void setNoRefresh(bool value);

    enum MessageState{
        DeviceHandling = 1,
        DeviceError = 2,
        Informative = 3,
        PowerSet = 4,
        IOSet = 5,
        DataSend = 6,
        DataRead = 7,
        ChipBad = 8,
        TestFailed = 9,
        TestPassed = 10
    };

    void AddMessage(int messageType, QString message, int stepNo = -1);

signals:

public slots:

private:
    QTreeWidget * logObject;
    bool noRefresh;
};

#endif // TESTLOG_H
